import * as React from "react";
export declare type OrientationType = "portrait" | "landscape";
export declare type SizeType = "xs" | "sm" | "md" | "lg" | "xl";
export interface SizesProps {
    xs?: number;
    sm?: number;
    md?: number;
    lg?: number;
    xl?: number;
}
export interface LayoutProps {
    size: SizeType;
}
export interface GridContextProps {
    size: SizeType;
    sizes: SizesProps;
    padding: number;
}
export declare const useGrid: () => Partial<GridContextProps>;
export interface GridProviderProps {
    padding?: number;
    breakpoints?: SizesProps;
    sizes?: SizesProps;
    showBreakpoints?: boolean;
    breakpointsColor?: string;
    children?: React.ReactNode;
}
export declare const useWindowResize: (breakpoints: SizesProps) => SizeType;
export declare const GridProvider: React.FC<GridProviderProps>;
//# sourceMappingURL=Provider.d.ts.map