"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GridProvider = exports.useWindowResize = exports.useGrid = void 0;
const React = __importStar(require("react"));
const react_native_1 = require("react-native");
const GridContext = React.createContext({ size: react_native_1.Platform.OS == "web" ? "lg" : "sm" });
const useGrid = () => React.useContext(GridContext);
exports.useGrid = useGrid;
const useWindowResize = (breakpoints) => {
    const { width } = react_native_1.useWindowDimensions();
    const getSize = () => {
        if (width < breakpoints["xs"]) {
            return "xs";
        }
        else if (width >= breakpoints["xs"] && width < breakpoints["sm"]) {
            return "sm";
        }
        else if (width >= breakpoints["sm"] && width < breakpoints["md"]) {
            return "md";
        }
        else if (width >= breakpoints["md"] && width < breakpoints["lg"]) {
            return "lg";
        }
        else {
            return "xl";
        }
    };
    const size = getSize();
    return size;
};
exports.useWindowResize = useWindowResize;
const defaultProps = {
    breakpoints: {
        xs: 500,
        sm: 730,
        md: 960,
        lg: 1450,
    },
    sizes: {
        xs: 12,
        sm: 6,
        md: 4,
        lg: 3,
        xl: 2,
    },
    padding: 16,
    showBreakpoints: false,
    breakpointsColor: "black",
};
const GridProvider = (props) => {
    let { children, breakpoints, sizes, padding, breakpointsColor, showBreakpoints } = props;
    const size = exports.useWindowResize(breakpoints);
    const renderBreakpoints = () => {
        if (!showBreakpoints)
            return null;
        const sizes = Object.keys(breakpoints);
        if (!sizes.length)
            return null;
        return sizes.map((size, index) => {
            const distance = breakpoints[size];
            if (!distance)
                return null;
            return <react_native_1.View key={index} style={[styles.breakpoint, { left: distance, backgroundColor: breakpointsColor }]}/>;
        });
    };
    return (<GridContext.Provider value={{ size, padding, sizes }}>
			{children}
			{renderBreakpoints()}
		</GridContext.Provider>);
};
exports.GridProvider = GridProvider;
exports.GridProvider.defaultProps = defaultProps;
const styles = react_native_1.StyleSheet.create({
    breakpoint: {
        position: "absolute",
        width: 1,
        top: 0,
        bottom: 0,
    },
});
